
#include <cstring>
#include <cstdlib>
#include <iostream>
#include "Foohash.H"
#include "Routerin.H"


using std::strcmp;
using std::cout;
using std::endl;

//put this in class ?? Util??
//FIXME:
static const std::string std_html_header= u8R"HUENERBLUBBE(<!DOCTYPE html>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <title>Sharing is Caring</title>
    <link rel="stylesheet" type="text/css" href="static/style.css">
  </head>
)HUENERBLUBBE" ;


static const std::string std_mainpage= u8R"HASENBLUBBE(
  <body>
    <div id="page">
      <h1>
        <span style="color: red">Sharing</span>
        <span style="color: blue">is</span>
        <span style="color: green">Caring</span>
      </h1>

      <div id="up">
        <form action="/upload" method="post" enctype="multipart/form-data">
          <input id="file" name="file" type="file">
          <input type="submit" value="Hochladen">
        </form>
        <p class="hint">
          Wie wärs mit einem schicken Foto? Dem Flyer der nächsten
          Party? Oder gar einem gesprochenen Kommentar?
        </p>
      </div>
)HASENBLUBBE" ;


static const std::string std_footer= u8R"FISCHBLUBBE(
      <p class="foot">
	Eine Guerilla-Kunstaktion von <b>&lt;&lt;&lt;/&gt;&gt;</b>
      </p>
    </div>
  </body>
</html>
)FISCHBLUBBE" ;


Routerin::Routerin():
	sfh( new StaticFileHandler())

{
	_dyn_obs = new DynamicObjects(this);
	cout << "Konstr Routering" << endl;
}

int Routerin::event_request_route(struct mg_event *event){
	const RouterOp *blub=0;
	Foohash fh;
	const char *reqstr=0;
	char *tmpstr = 0,*pntrstr=0;
	int retval=-1;
	reqstr=event->request_info->uri;
	if (reqstr){
		tmpstr = strdup(reqstr);
		std::cerr  << "starting with str as "
			<< tmpstr << endl; //DEBUG CODE
		pntrstr = strchrnul((tmpstr+1),'/');
		if (pntrstr) {
			*pntrstr = 0;
			std::cerr <<" having reqstr as " << tmpstr 
				<< " now. " << endl;
			std::cerr <<"len of reqstr is " <<
				( pntrstr - tmpstr) << endl;
			blub = fh.in_word_set(tmpstr,((pntrstr++)-tmpstr) );
			if (blub){
				std::cerr << "me has blub!!" <<endl;
				switch(blub->op){
					case RouterOpCode::FILES:
						retval = rq_file(pntrstr ,event);
						break;
					case RouterOpCode::DATE:
						retval = rq_date(pntrstr, event);
						break;
					case RouterOpCode::UPLOAD:
						retval = rq_upload(pntrstr, event);
						break;
					case RouterOpCode::STATIC:
						std::cerr << "(/static/ given)";
						retval = rq_static((pntrstr),event);
						break;
					default: 
						std::cerr << "fallback ";
						retval =  rq_static("illegalurl.htm",event); 
				};
			}else{
				std::cerr << "no blub! in " << __LINE__ << endl;
				//retval =  rq_static("illegalurl.htm",event); 
				retval = rq_render_mainpage(event);

			}
		}
		std::free(tmpstr);
		tmpstr=0;
		return retval;
	} else {
		std::cerr << "event request without uri? ?? hu? [" <<
			event->request_info->uri << "]" << endl;
	}
	return 0;
}


void Routerin::set_baseurl(std::string baseurl){
	_baseurl = baseurl;
	return;
}

int Routerin::rq_render_mainpage(struct mg_event * event){
	std::cerr << "rendering main page!" << endl;
	const std::string fubb = 
		std_html_header +
		std_mainpage +
		_dyn_obs->render_object_list()+
		std_footer.c_str() ;

	mg_printf(event->conn, "HTTP/1.0 200 OK\r\n"
			"Content-Length: %lu\r\n"
			"Content-Type: text/html\r\n\r\n%s",
			fubb.size(),
			fubb.c_str());

	return 1;
}



int Routerin::rq_static(char const * const reststr , struct mg_event *event)
{
	std::cerr << " a static file is reqested!" << endl;
	std::cerr << " path: " << reststr << endl;
	sfh->answer_pathreq(reststr,event->conn);
	return 1;
}



int Routerin::rq_file(char const * const reststr   ,
		struct mg_event *event __attribute__((unused)))
{
	std::cerr << " a dynamic file is reqested!" << endl;
	std::cerr << " path: " << reststr << endl;
	return 1;
}

int Routerin::rq_date(char const * const reststr   __attribute__((unused)),
		struct mg_event *event __attribute__((unused))  )
{
	std::cerr << "requested filelist ordered by date!" << endl ;
	return 1;
}

int Routerin::rq_upload(char const * const reststr __attribute__((unused)),
		struct mg_event *event  __attribute__((unused)))
{
	std::cerr << "here we will get uploadish!" << endl ;
	return 1;
}

int Routerin::event_requend_route(struct mg_event *event __attribute__((unused)) ){
	std::cerr << "ended request" <<endl;
	return 1;
}

int Routerin::event_fallback_route(struct mg_event *event __attribute__((unused)) ){
	//DEBUG CODE
	std::cerr << "Got an unhandled mg_event" << endl;
	std::cerr << "Its type is: " << event->type << endl;
	return 1;
}


int Routerin::event_newthread_route(struct mg_event *event __attribute__((unused)) ){
	//DEBUG CODE
	std::cerr << "Started new thread!" <<endl;
	return 1;
}





/*
 * 
static int event_handler(struct mg_event *event) {

	if (event->type == MG_REQUEST_BEGIN) {
		if (!strcmp(
		      event->request_info->uri,
		      "/handle_post_request")) {
			char path[200];
			FILE *fp = mg_upload(event->conn,
					"/tmp",
					path,
					sizeof(path));
			if (fp != NULL) {
				fclose(fp);
				mg_printf(event->conn,
					"HTTP/1.0 200 OK\r\n\r\nSaved: [%s]",
					path);
			} else {
				mg_printf(event->conn,"%s",
				  "HTTP/1.0 200 OK\r\n\r\nNo files sent");
			}
		} else {
			// Show HTML form. Make sure it has enctype="multipart/form-data" attr.
			static const char *html_form =
				"<html><body>Upload example."
				"<form method=\"POST\" action=\"/handle_post_request\" "
				"  enctype=\"multipart/form-data\">"
				"<input type=\"file\" name=\"file\" /> <br/>"
				"<input type=\"submit\" value=\"Upload\" />"
				"</form></body></html>";

			mg_printf(event->conn, "HTTP/1.0 200 OK\r\n"
					"Content-Length: %d\r\n"
					"Content-Type: text/html\r\n\r\n%s",
					(int) strlen(html_form), html_form);
		}

		// Mark request as processed
		return 1;
	}

	// All other events left unprocessed
	return 1;
}
*/


//REST API Documentation

///files/<zahl> (index in vector<Sicccobjst>)

///date/<datestring> (files am date hochgeladen)

///static/<mööp.html> (statisches html ausliefern)

///uploadmagic/        (upload form request)


